<template>

	<div v-if="date_visitor">
		
		<div class="modal fade"
			id="dateVisitorModal"
			tabindex="-1"
			role="dialog"
			aria-labelledby="dateVisitorModalLabel"
			aria-hidden="true">
			
			<div class="modal-dialog" role="document">
				<div class="modal-content">
					<div class="modal-header">
						<h5 class="modal-title" id="dateVisitorModalLabel">Información del visitante</h5>
						<button type="button" class="close" data-dismiss="modal" aria-label="Close">
						<span aria-hidden="true">&times;</span>
						</button>
					</div>
					<div class="modal-body">

						<div class="text-center" v-if="!status_updated">
							
							<div class="avatar xl mb-3 d-inline-block" :style="{backgroundImage: 'url(' + date_visitor.avatar + ')'}"></div>

							<div class="form-group">
								<p class="m-0 lead" v-text="date_visitor.full_name"></p>
								<p class="m-0" v-text="date_visitor.company_name"></p>
							</div>
			

							<div v-if="date_visitor.status_id == 4">
								
								<p class="text-danger">Esta cita ya se encuentra finalizada.</p>

								<a :href="date_route">Ver cita</a>

							</div>
	

							<form v-else action="" @submit.prevent="updated_date_visitor_status">
								<label for="" class="font-weight-bold mb-4">Modificar status:</label>

								<div class="form-row">
									<div class="col-sm-8">

										<select v-model="status_id" 
											v-if="date_visitor.status_id == 1" 
											name="" 
											id="" 
											class="custom-select" 
											required>

											<option disabled selected value="">Elige una opción</option>
											<option value="2">Ingresar</option>

										</select>
										
										<select v-model="status_id" 
											v-else-if="date_visitor.status_id == 2" 
											name=""
											id="" 
											class="custom-select"
											required>

											<option disabled selected value="">Elige una opción</option>
											<option value="3">Pausar cita</option>
											<option value="4">Finalizar</option>
										</select>

										<select v-model="status_id" 
											v-else-if="date_visitor.status_id == 3" 
											name="" 
											id="" 
											class="custom-select"
											required>

											<option disabled selected value="">Elige una opción</option>
											<option value="2">Continuar cita</option>
											<option value="4">Finalizar</option>
										</select>

									</div>
									<div class="col-sm-4">
										<button type="submit" class="btn btn-primary btn-block m-0">
											<i class="fa fa-check mr-2"></i>
											Confirmar
										</button>
									</div>
								</div>
							</form>

						</div>

						<div v-else>
							
							<p class="lead text-center text-success" v-text="status_updated_msg"></p>

						</div>

					</div>
				</div>
			</div>
			
		</div>

	</div>
	
</template>

<script>
	
	import Vue from 'vue';
	import VueBarcodeScanner from 'vue-barcode-scanner';

	Vue.use(VueBarcodeScanner);

	export default {

		data(){

			return {

				date_visitor: null,
				status_updated: 0,
				status_updated_msg: '',
				status_id: ''

			}

		},

		computed: {

			date_route(){

				let t = this;

				return t.$root.$data.root + '/dates/' + t.date_visitor.date_id;

			}

		},

		mounted(){

			$('#dateVisitorModal').on('hidden.bs.modal', function (e) {
				t.date_visitor = null
				t.status_updated = 0;
				t.status_updated_msg = 0;
				t.status_id = '';
			});

		},

		created () {
			// Add barcode scan listener and pass the callback function
			this.$barcodeScanner.init(this.onBarcodeScanned)
		},
		destroyed () {
			// Remove listener when component is destroyed
			this.$barcodeScanner.destroy()
		},
		methods: {
			// Create callback function to receive barcode when the scanner is already done
			onBarcodeScanned (barcode) {

				this.get_date_visitor(barcode);

				// do something...
			},
			// Reset to the last barcode before hitting enter (whatever anything in the input box)
			resetBarcode () {
				let barcode = this.$barcodeScanner.getPreviousCode()
				// do something...
			},

			get_date_visitor(barcode){


				let t = this;

				let token = t.$root.$data.token;

				let route = t.$root.$data.root + '/get-barcode-date';

				let data = new FormData();

				axios.get(route, {

					params: {

						_token: token,
						date_visitor_id: barcode,

					}

				}).then(({ data }) => {
				
					t.date_visitor = data;

					setTimeout(function(){

						$('#dateVisitorModal').modal('show');

					}, 150);
				
				}).catch(( error ) => {

					console.log(error.response);

				});


			},

			updated_date_visitor_status(){

				let t = this;

				let token = t.$root.$data.token;

				let route = t.$root.$data.root + '/update-date-visitor-status-with-barcode';

				let data = new FormData();

				data.append('_token', token);

				data.append('status_id', t.status_id);

				data.append('date_visitor_id', t.date_visitor.id);

				axios.post(route, data).then(({ data }) => {
				
					console.log(data);

					t.status_updated = 1;

					t.status_updated_msg = data;

					setTimeout(function(){

						t.date_visitor = null
						t.status_updated = 0;
						t.status_updated_msg = 0;
						t.status_id = '';

						$('#dateVisitorModal').modal('hide');

					},2000);
				
				});

			}
		}
		
	}

</script>